diff -trNau -U 3 -x '*o' -x '*.pyc' -x '*~*' -x '*.Log' -x NEWS -x CVS -x build sketch.orig/Sketch/Base/const.py sketch1/Sketch/Base/const.py
--- sketch.orig/Sketch/Base/const.py	2005-03-19 18:48:56.000000000 +0100
+++ sketch1/Sketch/Base/const.py	2005-03-19 20:27:08.000000000 +0100
@@ -83,6 +83,11 @@
 REMOVED = "REMOVED"
 META_CHANGED = "META_CHANGED"
 
+# REQUESTS
+SET_COLOR = 'SET_COLOR'
+CLEAR_REQUEST = 'CLEAR_REQUEST'
+REQUEST_COLOR = 'REQUEST_COLOR'
+
 #
 #       Scripting Access
 #
diff -trNau -U 3 -x '*o' -x '*.pyc' -x '*~*' -x '*.Log' -x NEWS -x CVS -x build sketch.orig/Sketch/UI/canvas.py sketch1/Sketch/UI/canvas.py
--- sketch.orig/Sketch/UI/canvas.py	2005-03-19 18:48:56.000000000 +0100
+++ sketch1/Sketch/UI/canvas.py	2005-03-19 20:27:08.000000000 +0100
@@ -509,11 +509,12 @@
     def set_window_cursor(self, cursor):
         if cursor != self.last_cursor:
             self.last_cursor = cursor
-            if type(cursor) == IntType:
+            if type(cursor) is gtk.gdk.CursorType:
                 cursor = gtk.gdk.Cursor(cursor)
                 # else, assume cursor is a cursor object
             self.window.set_cursor(cursor)
-
+            
+             
     #
     #
     #
diff -trNau -U 3 -x '*o' -x '*.pyc' -x '*~*' -x '*.Log' -x NEWS -x CVS -x build sketch.orig/Sketch/UI/colorpanel.py sketch1/Sketch/UI/colorpanel.py
--- sketch.orig/Sketch/UI/colorpanel.py	1970-01-01 01:00:00.000000000 +0100
+++ sketch1/Sketch/UI/colorpanel.py	2005-03-19 20:44:16.000000000 +0100
@@ -0,0 +1,378 @@
+import gtk
+ 
+from colorsys import rgb_to_hsv, hsv_to_rgb
+
+from Sketch import _, const, Editor
+from Sketch.Base import Publisher
+from Sketch.const import CHANGED
+from Sketch.Graphics import CreateRGBColor, SolidPattern
+
+from skpanel import Card, MultiPanel
+from command import make_command
+
+import dnd
+from rendermisc import PatternSample, ImageRenderer
+
+# XXX Currently not needed. Will be used in memo
+class PreviewFactory(PatternSample, ImageRenderer):
+    pass
+
+class ColorHandler(Publisher):
+
+    # the lock blocks the response of the widget when they are changed    
+    locked = 0
+    memo = None
+    def __init__(self, name, set_method, get_method):
+        self.name = name
+        self._set_method = set_method
+        self._get_method = get_method
+        
+    def lock(self):
+        self.locked = 1
+        
+    def unlock(self):
+        self.locked = 0
+
+    def set_color(self, color):
+        if self.locked: return
+
+        self.lock()
+        self._set_method(color)
+        self.unlock()
+        
+    def changed(self, *args):
+        """called when one of the assigned widgets is changed"""
+
+        if self.locked: return
+
+        color = self._get_method()
+        memo = color.red, color.green, color.blue
+
+        # avoid multiple notifications
+        if self.memo == memo:
+            return
+        
+        self.lock()
+
+        self.issue(CHANGED, color)
+        self.unlock()
+        self.memo = memo
+        
+class SketchColorSelection(gtk.VBox, Publisher):
+
+    def __init__(self):
+        gtk.VBox.__init__(self)
+
+        self.colorsel = gtk.ColorSelection()
+        self.notebook = gtk.Notebook()
+
+        self.steel_widgets()
+        self.build_wheel()
+        self.build_RGB()
+        self.build_CMY()
+        self.build_HSV()
+        self.build_BW()
+        
+        name = gtk.HBox()
+        l = gtk.Label(_("Color name:"))
+        name.add(l)
+        name.add(self.hexentry)
+        
+        self.add(self.notebook)
+        self.add(self.sample)
+        self.add(name)
+        self.show_all()
+        self.changed(self.get_wheel())
+        #self.connect("destroy", self.destroyed)
+
+    def changed(self, color):
+        self.issue(const.CHANGED, color)
+                
+    def _create_memo(self, context):
+        color, opacity = self.get()
+        memo = ColorMemo(self, context, color, opacity)
+        memo.show_all()
+        memo.show()
+        
+    def steel_widgets(self):
+        colorsel = self.colorsel
+        h = colorsel.get_children()[0]
+        v1, v2 = h.get_children()
+        hsv, sample = v1.get_children()
+
+        self.wheel = hsv
+        v1.remove(hsv)
+        
+        t, f = v2.get_children()
+
+        self.sample = sample
+        v1.remove(sample)
+        
+        hexentry, l = t.get_children()[:2]
+        self.hexentry = hexentry
+        t.remove(hexentry)
+
+    def build_wheel(self):
+        handler = ColorHandler("wheel", self.set_wheel, self.get_wheel)
+        self.Subscribe(CHANGED, handler.set_color)
+        handler.Subscribe(CHANGED, self.changed)
+        self.wheel.connect("changed", handler.changed)
+
+        page = gtk.Alignment(xalign=0.5, yalign=0.5)
+        page.add(self.wheel)
+        l = gtk.Label(_("Wheel"))
+        self.notebook.append_page(page, l)
+        page.show_all()
+        
+    def set_wheel(self, color):
+        self.colorsel.set_current_color(color)
+
+    def get_wheel(self):
+        return self.colorsel.get_current_color()
+            
+    def build_BW(self):
+        handler = ColorHandler("BW", self.set_BW, self.get_BW)
+        self.Subscribe(CHANGED, handler.set_color)
+        handler.Subscribe(CHANGED, self.changed)
+
+        page = gtk.Alignment(yalign=0.5, yscale = 0.5, xscale=1)
+        table = gtk.Table(2, 1)
+        l = gtk.Label(_("White:"))
+        l.set_alignment(1, 0.5)
+        l.set_padding(10, 2)
+        table.attach(l, 0, 1, 0, 1)
+        self.bw = gtk.Adjustment(0.0, 0.0, 100.0, 1.0, 1.0, 1.0)
+        s = gtk.SpinButton(self.bw, digits=1)
+        s.connect("changed", handler.changed)
+        table.attach(s, 1, 2, 0, 1)
+        page.add(table)
+        l = gtk.Label(_("BW"))        
+        self.notebook.append_page(page, l)
+
+    def get_BW(self):
+        val=int(0.5+self.bw.get_value()*65535./100.)
+        return gtk.gdk.Color(val, val, val)
+
+    def set_BW(self, color):
+        value = (color.red+color.green+color.blue)*100./(3*65535.)
+        self.bw.set_value(value)
+
+    def build_RGB(self):
+        handler = ColorHandler("RGB", self.set_RGB, self.get_RGB)
+        self.Subscribe(CHANGED, handler.set_color)
+        handler.Subscribe(CHANGED, self.changed)
+
+        page = gtk.Alignment(yalign=0.5, yscale = 0.5, xscale=1)
+
+        self.red = gtk.Adjustment(0.0, 0.0, 255, 1.0, 1.0, 1.0)
+        self.green = gtk.Adjustment(0.0, 0.0, 255, 1.0, 1.0, 1.0)
+        self.blue = gtk.Adjustment(0.0, 0.0, 255, 1.0, 1.0, 1.0)
+
+        table = gtk.Table(2, 3)
+        
+        row = 0
+        for text, adj in ((_("Red:"), self.red),
+                          (_("Green:"), self.green),
+                          (_("Blue:"), self.blue)):
+            l = gtk.Label(text)
+            l.set_alignment(1, 0.5)
+            l.set_padding(10, 2)
+            table.attach(l, 0, 1, row, row+1)
+
+            s = gtk.SpinButton(adj, digits=0)
+            s.connect("changed", handler.changed)
+            table.attach(s, 1, 2, row, row+1)
+            row = row+1
+            
+        table.show_all()
+        page.add(table)
+        l = gtk.Label(_("RGB"))
+        self.notebook.append_page(page, l)
+
+    def get_RGB(self):
+        r=int(0.5+self.red.get_value()*65535./255.)
+        g=int(0.5+self.green.get_value()*65535./255.)
+        b=int(0.5+self.blue.get_value()*65535./255.)
+        return gtk.gdk.Color(r, g, b)
+            
+    def set_RGB(self, color):
+        f = 255./65535.
+        self.red.set_value(f*color.red)
+        self.green.set_value(f*color.green)
+        self.blue.set_value(f*color.blue)
+
+    def build_CMY(self):
+        handler = ColorHandler("CMY", self.set_CMY, self.get_CMY)
+        self.Subscribe(CHANGED, handler.set_color)
+        handler.Subscribe(CHANGED, self.changed)
+
+        page = gtk.Alignment(yalign=0.5, yscale = 0.5, xscale=1)
+
+        self.cyan = gtk.Adjustment(0.0, 0.0, 100.0, 1.0, 1.0, 1.0)
+        self.magenta = gtk.Adjustment(0.0, 0.0, 100.0, 1.0, 1.0, 1.0)
+        self.yellow = gtk.Adjustment(0.0, 0.0, 100.0, 1.0, 1.0, 1.0)
+
+        table = gtk.Table(2, 3)
+        
+        row = 0
+        for text, adj in ((_("Cyan:"), self.cyan),
+                          (_("Magenta:"), self.magenta),
+                          (_("Yellow:"), self.yellow)):
+            l = gtk.Label(text)
+            l.set_alignment(1, 0.5)
+            l.set_padding(10, 2)
+            table.attach(l, 0, 1, row, row+1)
+
+            s = gtk.SpinButton(adj, digits=1)
+            s.connect("changed", handler.changed)
+            table.attach(s, 1, 2, row, row+1)
+            row = row+1
+            
+        table.show_all()
+        page.add(table)
+        l = gtk.Label(_("CMY"))
+        self.notebook.append_page(page, l)
+
+    def get_CMY(self, *args):
+        r = 100-int(0.5+self.cyan.get_value()*65535./100.)
+        g = 100-int(0.5+self.magenta.get_value()*65535./100.)
+        b = 100-int(0.5+self.yellow.get_value()*65535./100.)        
+        return gtk.gdk.Color(r, g, b)
+        
+    def set_CMY(self, color):
+        f = 100./65535.
+        self.cyan.set_value(100-f*color.red)
+        self.magenta.set_value(100-f*color.green)
+        self.yellow.set_value(100-f*color.blue)
+
+    def build_HSV(self):
+        handler = ColorHandler("HSV", self.set_HSV, self.get_HSV)
+        self.Subscribe(CHANGED, handler.set_color)
+        handler.Subscribe(CHANGED, self.changed)
+
+        page = gtk.Alignment(yalign=0.5, yscale = 0.5, xscale=1)
+
+        self.hue = gtk.Adjustment(0.0, 0.0, 100.0, 1.0, 1.0, 1.0)
+        self.saturation = gtk.Adjustment(0.0, 0.0, 100.0, 1.0, 1.0, 1.0)
+        self.brightness = gtk.Adjustment(0.0, 0.0, 100.0, 1.0, 1.0, 1.0)
+
+        table = gtk.Table(2, 3)
+
+        row = 0
+        for text, adj in ((_("Hue:"), self.hue),
+                          (_("Saturation:"), self.saturation),
+                          (_("Brightness:"), self.brightness)):
+            l = gtk.Label(text)
+            l.set_alignment(1, 0.5)
+            l.set_padding(10, 2)
+            table.attach(l, 0, 1, row, row+1)
+
+            s = gtk.SpinButton(adj, digits=1)
+            s.connect("changed", handler.changed)
+            table.attach(s, 1, 2, row, row+1)
+            row = row+1
+            
+        page.add(table)
+        table.show_all()
+        l = gtk.Label(_("HSV"))
+        self.notebook.append_page(page, l)
+
+    def get_HSV(self):
+        f = 1./101.
+        h = f*self.hue.get_value()
+        
+        s = f*self.saturation.get_value()
+        v = f*self.brightness.get_value()
+        r, g, b = map(lambda x:int(x*65535), hsv_to_rgb(h, s, v))
+        return gtk.gdk.Color(r, g, b)
+        
+    def set_HSV(self, color):
+        f = 1/65536.
+        h, s, v = rgb_to_hsv(f*color.red, f*color.green, f*color.blue)
+        f = 101
+        self.hue.set_value(f*h)
+        self.saturation.set_value(f*s)
+        self.brightness.set_value(f*v)
+        
+    def set_current_color(self, color):        
+        cmap = self.get_colormap()
+        r, g, b = color
+        gdk_color = cmap.alloc_color(int(round(0xFFFF * r)),
+                                     int(round(0xFFFF * g)),
+                                     int(round(0xFFFF * b)))
+        self.colorsel.set_current_color(gdk_color)
+                    
+    def set_previous_color(self, color):
+        cmap = self.get_colormap()
+        r, g, b = color
+        gdk_color = cmap.alloc_color(int(round(0xFFFF * r)),
+                                     int(round(0xFFFF * g)),
+                                     int(round(0xFFFF * b)))
+        self.colorsel.set_previous_color(gdk_color)
+
+    def get(self):
+        gdk_color = self.colorsel.get_current_color()
+        #opacity = self.colorsel.get_current_alpha()/65535.
+        color = CreateRGBColor(gdk_color.red / 65536.0,
+                               gdk_color.green / 65536.0,
+                               gdk_color.blue / 65536.0)
+        return color
+
+
+class ColorCard(Card):
+    def __init__(self, application):        
+        Card.__init__(self, application, _("Color"))
+        
+    def build_card(self):
+        self.colorsel = SketchColorSelection()
+        self.colorsel.Subscribe(CHANGED, self.color_changed)
+        self.pack_start(self.colorsel)
+        self.show_all()
+
+    def set_current_color(self, color):        
+        self.colorsel.set_current_color(color)
+                    
+    def set_previous_color(self, color):
+        self.colorsel.set_previous_color(color)
+
+    def color_changed(self, *args):
+        requesthandler = self.context.application.requesthandler
+        requesthandler.SetColor(self.colorsel.get())
+        
+class ColorPanel(MultiPanel):
+    multiple = 1
+    def __init__(self, context):        
+        MultiPanel.__init__(self, context, _("Color"))
+        requesthandler = self.context.application.requesthandler
+        requesthandler.AddColorPanel()
+        requesthandler.Subscribe(const.REQUEST_COLOR,
+                                 self.color_requested)
+
+    def destroyed(self, *args):
+        requesthandler = self.context.application.requesthandler
+        requesthandler.RemoveColorPanel()
+        requesthandler.Unsubscribe(const.REQUEST_COLOR,
+                                   self.color_requested)
+        MultiPanel.destroyed(self)
+        
+    def build_window(self):
+        MultiPanel.build_window(self)
+
+        self.build_menu()
+
+        color_card = ColorCard(self.context.application)
+        self.attach_card(color_card)
+        self.color_card = color_card
+        
+    def build_menu(self):        
+        items = ('close_panel',
+                 'duplicate_panel')            
+        #menudata = Editor.BuildMenuTree('<colorpanelmenu>', '', items)
+        import tmpmenu
+        menudata = tmpmenu.BuildMenuTree('<colorpanelmenu>', '', items)
+        self.set_menudata(menudata)
+        
+    def color_requested(self, color):
+        self.Raise()
+        self.color_card.set_previous_color(color)
+
diff -trNau -U 3 -x '*o' -x '*.pyc' -x '*~*' -x '*.Log' -x NEWS -x CVS -x build sketch.orig/Sketch/UI/command.py sketch1/Sketch/UI/command.py
--- sketch.orig/Sketch/UI/command.py	2005-03-19 18:48:56.000000000 +0100
+++ sketch1/Sketch/UI/command.py	2005-03-19 20:27:08.000000000 +0100
@@ -16,8 +16,19 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 from Sketch.Editor import Command
+from types import TupleType
 
 class WindowCommand(Command):
 
     def Sensitive(self, context):
         return context.window is not None and Command.Sensitive(self, context)
+
+def make_command(label, func = None, args = (), sensitive = None):
+    # XXX extend options
+    if type(label) == TupleType:
+            return apply(make_command, label)
+
+    if label is None:
+        return None
+    return Command("", label, func, args, sensitive=sensitive)
+    
diff -trNau -U 3 -x '*o' -x '*.pyc' -x '*~*' -x '*.Log' -x NEWS -x CVS -x build sketch.orig/Sketch/UI/contextproxy.py sketch1/Sketch/UI/contextproxy.py
--- sketch.orig/Sketch/UI/contextproxy.py	1970-01-01 01:00:00.000000000 +0100
+++ sketch1/Sketch/UI/contextproxy.py	2005-03-19 20:27:08.000000000 +0100
@@ -0,0 +1,69 @@
+
+from Sketch.Base import Publisher
+
+
+class ContextProxy(Publisher):
+    """A generic class to create special contexts.
+    """
+
+    # list of own signals
+    channels = ()
+
+    # the parent (usually an application context)
+    parent = None
+    
+    def __init__(self, parent=None):
+
+        # Channels which are forwarded from the parent. The channal
+        # name is translated upon forwarding. The key is the original
+        # name, value is the new one.        
+        self.forwarded_channels = {}
+        
+        if parent is not None:
+            self.SetParent(parent)
+
+    def __getattr__(self, name):
+        #print "ContextProxy(%i): can't find " % id(self), name
+        if self.parent is None:
+            raise AttributeError()
+        return getattr(self.parent, name)
+
+    def forward(self, *args):
+        args = (args[-1],) + args[:-1]
+        #print "forwarding ", args, self
+        apply(self.issue, args)
+    
+    def SetParent(self, parent):
+        if self.parent is not None:
+            self.UnsetParent()
+        self.parent = parent
+        for channel, alias in self.forwarded_channels.items():
+            parent.Subscribe(channel, self.forward, alias)
+
+    def UnsetParent(self):
+        parent = self.parent
+        for channel, alias in self.forwarded_channels.items():
+            parent.Unsubscribe(channel, self.forward, alias)
+        self.parent = None
+
+    def AddForward(self, channel, alias=None):
+        if alias is None:
+            alias = channel
+        if self.parent is not None:
+            self.parent.Subscribe(channel, self.forward, alias)
+        self.forwarded_channels[channel] = alias
+
+    def Subscribe(self, channel, func, *args):
+
+        # check whether the channel needs to be forwarded
+        if not (channel in self.channels or
+                channel in self.forwarded_channels):
+            self.AddForward(channel)
+        
+        Publisher.Subscribe(self, channel, func, *args)
+       
+    def Destroy(self):
+        #print "destroying context ", self
+        self.UnsetParent()
+        Publisher.Destroy(self)
+        
diff -trNau -U 3 -x '*o' -x '*.pyc' -x '*~*' -x '*.Log' -x NEWS -x CVS -x build sketch.orig/Sketch/UI/dnd.py sketch1/Sketch/UI/dnd.py
--- sketch.orig/Sketch/UI/dnd.py	1970-01-01 01:00:00.000000000 +0100
+++ sketch1/Sketch/UI/dnd.py	2005-03-19 20:27:08.000000000 +0100
@@ -0,0 +1,23 @@
+from Sketch.Graphics import CreateRGBColor
+
+color_target = [('application/x-color', 0, 0)]
+
+
+def encode_color(color, opacity=1.):
+    data = ""
+    for a in tuple(color)+(opacity,):
+        i = int(a*65535.+0.5)                
+        data += chr(i & 255) + chr(i >> 8)
+    return data
+            
+def decode_color(data):
+    def decode(s):
+        b, a = map(ord, s)                
+        return ((a << 8) + b)/ 65535.
+    bin = data.data
+    r = decode(bin[:2])
+    g = decode(bin[2:4])
+    b = decode(bin[4:6])
+    #opacity = decode(bin[6:8])            
+    color = CreateRGBColor(r, g, b)
+    return color
